<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Api_Discipline extends Controller_Api_Handler {

    # todo: rights / privileges control

    # GET: /api/discipline/723
    public function action_index() {
        $id = $this->request->param('id', 0);
        return Model_Discipline::load($id);
    }

    # POST: /api/discipline/create
    public function action_create() {
        $semester = isset($this->post['semesterID'])
            ? $this->post['semesterID']
            : $this->user->SemesterID;

        $discipline = Model_Discipline::make()
            ->author  ($this->user['TeacherID'])
            ->faculty ($this->post['facultyID'])
            ->subject ($this->post['subjectID'])
            ->grade   ($this->post['gradeID'])
            ->lectures($this->post['lectures'])
            ->practice($this->post['practice'])
            ->labs    ($this->post['labs'])
            ->type    ($this->post['type'])
            ->semester($semester)
            ->create();

        if ($this->post['bonus'] == "true")
            Model_Map::AddModuleBonus($this->user['TeacherID'], $discipline->ID);

        return ['ID' => $discipline->ID];
    }

    # PUT: /api/discipline/update/723
    public function action_update() {
        $id = $this->request->param('id', 0);

        if ($id <= 0)
            throw new InvalidArgumentException(Error::ID_IS_INCORRECT);

        throw new LogicException('Not implemented yet');
    }

    # DELETE: /api/discipline/delete/723
    public function action_delete() {
        $id = (int) $this->request->param('id', 0);
        $discipline = Model_Discipline::load($id);

        // delete only if discipline cleared (doesn't exists related rating's records)
        if ($discipline->authorID != $this->user['TeacherID'])
            throw new LogicException(Error::ILLEGAL_ACCESS);
        if ($discipline->isLocked)
            throw new LogicException(Error::DISCIPLINE_IS_LOCKED);
        if (Model_Rating::count($discipline) > 0)
            throw new LogicException(Error::DISCIPLINE_IS_LOCKED);

        $discipline->delete();
    }
}